/*
	xchat-turnround.c
	-----------------
	turns what you type around (hehe --> eheh)
	(gets annoying quickly, have fun)
	
	lamagra <access-granted@geocities.com>
        http://bounce.to/unah16

*/

#define PLUGIN_NAME "turnround"
#define PLUGIN_DESC "snrut ffuts dnuora"

#define USE_PLUGIN

#include <ctype.h>
#include <string.h>
#include "xchat.h"
#include "plugin.h"

/* globals */
extern struct module *module_find(char *name);
struct xp_signal chanmsg_sig;
char *name = PLUGIN_NAME;
char *desc = PLUGIN_DESC;

/* prototypes */
void turn(char *, char *);
int chanmsg (struct server *, char *, char *, char *, void *, char );
int (*chanmsg_next) (void *, void *, void *, void *, void *, char);

int module_init(int ver, struct module *mod, struct session *sess)
{
	if (ver != MODULE_IFACE_VER)
		return 1;
	
	if (module_find (name) != NULL)
	{
		PrintText(sess, "\0035      Module " PLUGIN_NAME " already loaded \003 \n");
		return 1;
	}
	PrintText(sess, "\0035      Loaded module " PLUGIN_NAME "\003 \n");
	mod->name = name;
	mod->desc = desc;
		
	chanmsg_sig.signal = XP_CHANMSG;
	chanmsg_sig.callback = XP_CALLBACK(chanmsg);
	chanmsg_sig.naddr = &chanmsg_next;
	chanmsg_sig.mod = mod;

	hook_signal(&chanmsg_sig);

	return 0;
}

void module_cleanup(struct module *mod, struct session *sess)
{
	PrintText(sess, "\0035      Unloaded module " PLUGIN_NAME "\003 \n");
}

int chanmsg(struct server *serv, char *from, char *ip, char *text, void *a, char c)
{
	struct	session	*sess;
	char	buf[1024];
	
	sess = serv->front_session;
	
	memset(buf, 0, sizeof(buf));
	turn(buf, text);
	
	strcpy(text, buf);
	
	XP_CALLNEXT(chanmsg_next, serv, from, ip, text, a, c);
}


void turn(char *turned, char *text)
{
   char toksep[] =" ";
   char *pt, temp[2];
   char turn_buf[1024];
   int  x;

   pt = strtok(text, toksep);
   memset(turn_buf,0x0,1024);
   if(pt){
    do{
          for(x = strlen(pt) - 1; x != -1 ; x--)
         {
	     sprintf(temp,"%c",pt[x]);
             strncat(turn_buf,temp,1);
         }
         strncat(turn_buf," ",1);
    }while(pt = strtok(NULL, toksep));
    strcpy(turned, turn_buf);
   }
   else strcpy(turned, text);
}
